#ifndef IBN_DEVICE_FAKE_DELAY_LINE_H
#define IBN_DEVICE_FAKE_DELAY_LINE_H
#include "DelayLine.h"
#include <chrono>
namespace device 
{
	class FakeDelayLine : public DelayLine
	{
		device::Info info;
		delay_t delay;
		public:
		typedef std::chrono::nanoseconds delay_t;
		FakeDelayLine(std::string name, std::string address="") 
		{
			info.type = "DelayLine";
			info.model = "FAKE";
			info.address = address;
			info.name = name;
		}

		virtual ~FakeDelayLine(void){}
		virtual delay_t GetDelay(void) const final { return delay;};
		virtual void SetDelay(const delay_t & time) final { delay = time; };
		const Info & GetInfo() const final { return info; }
	};
}
#endif
