#ifndef IBN_DEVICE_FAKE_GENERATOR_H
#define IBN_DEVICE_FAKE_GENERATOR_H

#include "Generator.h"

namespace device 
{
	class FakeGenerator : public device::Generator 
	{
		public:
			FakeGenerator ( std::string name, std::string address="")  
			{
				info.name = name;
				info.type = "Generator";
				info.model = "FAKE";
				info.address = address;
			}
			virtual ~FakeGenerator(void) {}
			void On(void) final { ison = true; } 
			void Off(void) final { ison = false;  frequency = 0; } 
			bool IsOn(void) const final {return ison;};

			const Info & GetInfo() const final { return info; }

			void SetFrequency(double f /* Hz */) final { frequency = f; }

			void GenerateFrequency(double f /* Hz */, const std::chrono::duration<double, std::ratio<1,1>> & time /* sec */) final 
			{
				SetFrequency(f);
				std::this_thread::sleep_for(time);
			}
			double GetFrequency(void)  const  final { return frequency; }
		private:
			bool ison;
			double frequency;
			Info info;
	};
}

#endif
