#ifndef IBN_DEVICE_POWER_SUPPLY_H
#define  IBN_DEVICE_POWER_SUPPLY_H
#include "Device.h"

namespace device 
{
	class PowerSupply : public Device 
	{
		public:
			virtual ~PowerSupply(void) {};

			virtual void On(void) = 0;
			virtual void Off(void) = 0;
			virtual void Reset(void) = 0;
			virtual void SetVoltage(double V)  = 0;

			virtual double GetVoltage(void ) const = 0;
			virtual double GetMaxVoltage(void) const  = 0;
			virtual double GetStepVoltage(void)  const  = 0;

			virtual bool   IsOn(void) const  = 0;
			virtual bool   IsOverload(void) const  = 0;
			virtual bool   IsVoltageOverload(void) const  = 0;
			virtual bool   IsCurrentOverload(void) const  = 0;
	};
}

#endif
